#!/usr/bin/python3
#This script starts the Runtime "GrafcetEngine". Grafcet-Studio can then connect to the device. See www.mhj-wiki.de
from GrafcetEngineRuntime import GrafcetEngine #import Grafcet-Engine

engine=GrafcetEngine() #Create an instance of the Grafcet Engine

#Init the communication over MQTT
#!!! IMPORTANT !!!
#This settings MUST match with the settings in Grafcet-Studio: IP address, Topic1 and Topic 2
#parameters: url of broker, topic1 and topic2 , 
mqttOk=engine.InitMqtt("127.0.0.1","mh","iot2020") #change Topic1 and Topic 2: at least 3 characters

if mqttOk: print("MQTT OK") #is ok
else:print("!!!!! MQTT Error") #error

#Loop for processing 
print("Start Grafcet loop...")
try:
    while True: #loop
            #read hardware inputs and write these values into the inputs of the Grafcet-Engine
            #...
            
            #Call Grafcet-Engine
            engine.GrafcetCyclic()

            #write all outputs from the Grafcet-Engine to the hardware
            #...

except KeyboardInterrupt: #Ctrl+C pressed? Then exit
    pass
engine.exit() #exit and close Grafcet-Engine
print("End of Python script")


