#!/usr/bin/python3
#This script starts the Runtime "GrafcetEngine". Grafcet-Studio can then connect to the device. See www.mhj-wiki.de
from GrafcetEngineRuntime import GrafcetEngine #import Grafcet-Engine
import RPi.GPIO as GPIO

GPIO.setmode(GPIO.BCM) #use BCM-numbering for the pins
GPIO.setup(14, GPIO.OUT) #setup pin as output
GPIO.setup(15, GPIO.OUT) #setup pin as output
GPIO.setup(18, GPIO.OUT) #setup pin as output
GPIO.setup(23, GPIO.OUT) #setup pin as output

engine=GrafcetEngine() #Create an instance of the Grafcet Engine

#Init the communication over MQTT
#!!! IMPORTANT !!!
#This settings MUST match with the settings in Grafcet-Studio: IP address, Topic1 and Topic 2
#parameters: url of broker, topic1 and topic2 , 
mqttOk=engine.InitMqtt("broker.mqttdashboard.com","???","???") #change Topic1 and Topic 2: at least 3 characters
if mqttOk: print("MQTT OK") #is ok
else:print("!!!!! MQTT Error") #error

#Loop for processing 
print("Start Grafcet loop...")
try:
    while True: #loop
            #read hardware inputs and write these values into the inputs of the Grafcet-Engine
            byteAddr=0; #DI starts at address 0. See symbolic table in Grafcet-Studio 
            bitAddr=0
            engine.write_bit(byteAddr,bitAddr,1);bitAddr+=1
            engine.write_bit(byteAddr,bitAddr,0);bitAddr+=1
            engine.write_bit(byteAddr,bitAddr,1);bitAddr+=1
            engine.write_bit(byteAddr,bitAddr,0);bitAddr+=1
            
            #Call Grafcet-Engine
            engine.GrafcetCyclic()

            #write all outputs from the Grafcet-Engine to the hardware
            byteAddr=25 #DO starts at address 25. See symbolic table in Grafcet-Studio
            bitAddr=0
            #read outputs from the grafcet-engine
            Q0=engine.read_bit(byteAddr,bitAddr);bitAddr+=1
            Q1=engine.read_bit(byteAddr,bitAddr);bitAddr+=1
            Q2=engine.read_bit(byteAddr,bitAddr);bitAddr+=1
            Q3=engine.read_bit(byteAddr,bitAddr);bitAddr+=1
            #write outputs to the pins
            GPIO.output(14, GPIO.HIGH) if Q0 else GPIO.output(14, GPIO.LOW)
            GPIO.output(15, GPIO.HIGH) if Q1 else GPIO.output(15, GPIO.LOW)
            GPIO.output(18, GPIO.HIGH) if Q2 else GPIO.output(18, GPIO.LOW)
            GPIO.output(23, GPIO.HIGH) if Q3 else GPIO.output(23, GPIO.LOW)
except KeyboardInterrupt: #Ctrl+C pressed? Then exit
    pass
engine.exit() #exit and close Grafcet-Engine
print("End of Python script")


