#!/usr/bin/python3
#This script starts the Runtime "GrafcetEngine". Grafcet-Studio can then connect to the device. See www.mhj-wiki.de

from GrafcetEngineRuntime import GrafcetEngine #import Grafcet-Engine
import time


engine=GrafcetEngine() #Create an instance of the Grafcet Engine

#Init the communication over MQTT
#!!! IMPORTANT !!!
#This settings MUST match with the settings in Grafcet-Studio: IP address, Topic1 and Topic 2
#parameters: url of broker, topic1 and topic2 , 
mqttOk=engine.InitMqtt("broker.mqttdashboard.com","mh0","pc0") #change Topic1 and Topic 2: at least 3 characters
#mqttOk=engine.InitMqtt("127.0.0.1","mh","pc") #url of broker, topic1 and topic2
if mqttOk: print("MQTT OK") #is ok
else:print("!!!!! MQTT Error") #error


timeOldStatusMessage=time.time() #for status messages

#Loop for processing 
print("Start Grafcet loop...")
try:
    while True: #loop
            #read hardware inputs and write these values into the inputs of the Grafcet-Engine
            
            #Call Grafcet-Engine
            engine.GrafcetCyclic()
            
            #write all outputs from the Grafcet-Engine to the hardware            

            # each second send the monitoring info
            if time.time()-timeOldStatusMessage>1: 
                print("Grafcet-Run={}, Cyclic time={}ms".format(engine.GrafcetEngineStatus.GrafcetRun, engine.GrafcetEngineStatus.PlcCyclicTimeMs))
                timeOldStatusMessage=time.time()
            
except KeyboardInterrupt: #Ctrl+C pressed? Then exit
    pass
engine.exit() #exit and close Grafcet-Engine
print("End of Python script")


