#!/usr/bin/python3
#This script starts the Runtime "GrafcetEngine". Grafcet-Studio can then connect to the device. See www.mhj-wiki.de

from GrafcetEngineRuntime import GrafcetEngine #import Grafcet-Engine
import pibrella #import the library for the shield

engine=GrafcetEngine() #Create an instance of the Grafcet Engine

#Init the communication over MQTT
#!!! IMPORTANT !!!
#This settings MUST match with the settings in Grafcet-Studio: IP address, Topic1 and Topic 2

#parameters: url of broker, topic1 and topic2 , 
mqttOk=engine.InitMqtt("broker.mqttdashboard.com","???","???") #change Topic1 and Topic 2: at least 3 characters
if mqttOk: print("MQTT OK") #is ok
else:print("!!!!! MQTT Error") #error

#Loop for processing 
print("Start Grafcet loop...")
try:
    while True: #loop
            #read hardware inputs and write these values into the inputs of the Grafcet-Engine
            byteAddr=0; #DI starts at address 0. See symbolic table in Grafcet-Studio 
            bitAddr=0
            engine.write_bit(byteAddr,bitAddr,pibrella.button.read());bitAddr+=1
            
            #Call Grafcet-Engine
            engine.GrafcetCyclic()

            #write all outputs from the Grafcet-Engine to the hardware
            byteAddr=25 #DO starts at address 25. See symbolic table in Grafcet-Studio
            bitAddr=0
            #read outputs from the grafcet-engine
            Q0=engine.read_bit(byteAddr,bitAddr);bitAddr+=1
            Q1=engine.read_bit(byteAddr,bitAddr);bitAddr+=1
            Q2=engine.read_bit(byteAddr,bitAddr);bitAddr+=1
            Q3=engine.read_bit(byteAddr,bitAddr);bitAddr+=1

            #write outputs to the pins
            pibrella.light.green.on() if Q0 else pibrella.light.green.off()
            pibrella.light.yellow.on() if Q1 else pibrella.light.yellow.off()
            pibrella.light.red.on() if Q2 else pibrella.light.red.off()
            pibrella.buzzer.buzz( 440 ) if Q3 else pibrella.buzzer.off()
            
except KeyboardInterrupt: #Ctrl+C pressed? Then exit
    pass
engine.exit() #exit and close Grafcet-Engine
print("End of Python script")


